/******************************************************************************
 *  Derleme:  	   javac BilmeceTesti.java
 *  Çalıştırma:    java BilmeceTesti.java kutuk1.txt kutuk2.txt ...
 *  Bağımlılıklar: Tahta.java Çözücü.java
 *
 *  Bu program belirtilen her kütükten bir başlangıç tahtası oluşturur
 *  ve hedef konuma ulaşmak için yapılması gereken en düşük hamle sayısını
 *  bulur.
 *
 *  % java BilmeceTesti bilmece*.txt
 *  bilmece00.txt: 0
 *  bilmece01.txt: 1
 *  bilmece02.txt: 2
 *  bilmece03.txt: 3
 *  bilmece04.txt: 4
 *  bilmece05.txt: 5
 *  bilmece06.txt: 6
 *  ...
 *  bilmece3x3-cozumuyok: -1
 *  ...
 *  bilmece42.txt: 42
 *  bilmece43.txt: 43
 *  bilmece44.txt: 44
 *  bilmece45.txt: 45
 *
 ******************************************************************************/

import edu.princeton.cs.algs4.In;
import edu.princeton.cs.algs4.StdOut;

public class BilmeceTesti
{

    public static void main(String[] args) {

        // her bir komut satırına geçilen argüman için
        for (String kütük : args)
		{

            // kütükten bilmeceyi oku
            In giriş = new In(kütük);
            int N = giriş.readInt();
            int[][] taşlar = new int[N][N];
            for (int i = 0; i < N; i++) {
                for (int j = 0; j < N; j++)
				{
                    taşlar[i][j] = giriş.readInt();
                }
            }

            // bulmacayı çöz
            Tahta ilk = new Tahta(taşlar);
            Çözücü çözücü = new Çözücü(ilk);
            StdOut.println(kütük + ": " + çözücü.hamleler());
        }
    }
}
